#version 150 core

out vec4 outColor;

uniform sampler2D diffuseMap;
uniform sampler2D lightMap;
uniform sampler2D materialBuffer;
uniform float fade;

in vec2 uv0;

void main( void )
{
	vec4 diffuse = texture(diffuseMap, uv0);
	float matIndex = diffuse.a * 255.0 + 1.0;
	float dx = 1.0 / 8.0;   // width * 2
	float dy = 1.0 / 512.0; // heght * 2
	vec4 combineParams = texture( materialBuffer, vec2(dx * (1.0 * 2.0 - 1.0), dy * (matIndex * 2.0 - 1.0)) );
	
    outColor = (combineParams.r * diffuse + texture(lightMap, uv0) * combineParams.g) * fade;
}
