#version 150 core

in vec4 in_Position;
in vec3 in_Normal;
#if defined(TEXTURE) || defined(NORMALMAP)
in vec2 in_UV0;
#endif
#if defined(NORMALMAP)
in vec3 in_Tangent;
in vec3 in_Bitangent;
#endif

#if defined(TEXTURE) || defined(NORMALMAP)
out vec2 uv0;
#endif
#if defined(NORMALMAP)
out vec3 tangent;
out vec3 bitangent;
#endif

out vec3 normal;

uniform mat4 projM;
uniform mat4 cameraM;
uniform mat4 modelM;
uniform mat3 normalM;

void main( void )
{
	normal = normalize(normalM * in_Normal);
#if defined(TEXTURE) || defined(NORMALMAP)
    uv0 = in_UV0;
#endif
#if defined(NORMALMAP)
	tangent = normalize(normalM * in_Tangent);
	bitangent = normalize(normalM * in_Bitangent);
#endif
	gl_Position = projM * cameraM * modelM * in_Position;
}