#version 150 core

in vec4 in_Position;

uniform mat4 projM;
uniform mat4 lightM;

out vec3 viewRay;

void main( void )
{
#ifdef DIRECTIONAL_LIGHT
	viewRay = (lightM * in_Position).xyz;
	gl_Position = in_Position;
#endif
#ifdef POINT_LIGHT
	viewRay = (lightM * in_Position).xyz;
	gl_Position = projM * lightM * in_Position;
#endif
#ifdef CONE_LIGHT
	viewRay = (lightM * in_Position).xyz;
	gl_Position = projM * lightM * in_Position;
#endif
}
