#version 150 core

in vec4 in_Position;
in vec2 in_UV0;

uniform mat4 objectMatrix;
uniform mat4 lightM;
uniform mat4 projM;

out vec3 viewRay;
out mat3 lightRot;

mat3 mat3_emu(mat4 m4) 
{
  return mat3(
      m4[0][0], m4[0][1], m4[0][2],
      m4[1][0], m4[1][1], m4[1][2],
      m4[2][0], m4[2][1], m4[2][2]);
}

void main( void )
{
	viewRay = (lightM * in_Position).xyz;
	lightRot = mat3_emu(objectMatrix) * mat3_emu(inverse(lightM));
	gl_Position = projM * lightM * in_Position;
}
