#version 150 core

in vec4 in_Position;
in vec3 in_Normal;
in vec2 in_UV0;

uniform mat4 ProjM;
uniform mat4 ModelM;
uniform mat3 NormalM;
uniform vec2 UVScroll;

out vec2 uv0;
out vec3 normals;

void main( void )
{
	normals = normalize(NormalM * in_Normal);
    uv0 = in_UV0 + UVScroll;
	gl_Position = ProjM * ModelM * in_Position;
}