#version 150 core
#extension GL_ARB_explicit_attrib_location : enable

layout(location = 0) out vec4 fragColor;
layout(location = 1) out vec4 fragNormal;

uniform vec4 background_color;
uniform float MaterialIndex;
uniform sampler2D maskTexture;
uniform sampler2D frequency;
uniform vec2 repeat;

in vec2 uv0;
in vec3 normals;

void main( void )
{
	vec2 tx = uv0 * repeat;
	vec4 diffuse = texture(maskTexture, tx);
	float mask = texture(frequency, uv0).r;
	
	vec4 c1 = vec4(background_color.rgb, MaterialIndex/255.0);
	vec4 c2 = vec4(diffuse.rgb * diffuse.a * mask, 4.0 / 255.0);
	
	if(diffuse.a == 0.0)
	{
		fragColor = c1;
	}
	else
	{
		fragColor = c2;
	}
	fragNormal = vec4(normalize(normals.xyz), 0.0); // normals
}
