#version 150 core
#extension GL_ARB_explicit_attrib_location : enable

layout(location = 0) out vec4 fragColor;
layout(location = 1) out vec4 fragNormal;

uniform sampler2D freqTexture;
uniform vec4 foreground_color;
uniform vec2 scale;
uniform float MaterialIndex;

in vec3 normals;
in vec2 uv0;

void main() 
{
	float x = mod(uv0.x * scale.x, 1.0);
	float y = mod(uv0.y * scale.y, 1.0);

	float v = 1.0 - texture(freqTexture, vec2(uv0.x, 0.0)).r;
	v = ceil(v * scale.y);
	float ycoord = ceil((1.0 - uv0.y) * scale.y);

	vec4 c1 = vec4(foreground_color.rgb, 255.0 / 255.0);
	vec4 c2 = vec4(vec3(0.0, 0.0, 1.0), MaterialIndex/255.0);
	
	if(x > 0.1 && x < 0.9 && y > 0.2 && y < 0.8 && ycoord > v) 
	{
		fragColor = c1;
	}
	else 
	{
		fragColor = c2;
	}
	fragNormal = vec4(normalize(normals.xyz), 0.0); // normals	
}
