#version 150 core

out vec4 fragColor;

uniform sampler2D texture0;
uniform sampler2D noise;
uniform vec2 screen;
uniform vec2 noise_scroll0;
uniform vec2 noise_scroll1;
uniform vec2 noise_scroll2;

in vec4 pos;
//in vec3 normal;
in vec2 uv0;

void main( void )
{
	float noise_value0 = texture(noise, (uv0 * vec2(1.0, 0.25)) + noise_scroll0).r;
	float noise_value1 = texture(noise, (uv0 * vec2(2.0, 0.50)) + noise_scroll1).r;
	float noise_value2 = texture(noise, (uv0 * vec2(4.0, 1.00)) + noise_scroll2).r;

    float noise_value_final = (noise_value0 + noise_value1 + noise_value2) / 3.0;

	float x = clamp(noise_value_final, 0.0, 1.0) - 0.5;
	float y = clamp(noise_value_final, 0.0, 1.0) - 0.5;

	vec2 uv = (gl_FragCoord.xy / screen) + (vec2(x,-y) / 5.0);
	fragColor = texture(texture0, uv) - vec4(noise_value_final/10.0);
//	fragColor = texture(texture0, uv);	
}
