#version 150 core

in vec4 in_Position;
//in vec3 in_Normal;
in vec2 in_UV0;

uniform mat3 NormalM;
uniform mat4 ProjM;
uniform mat4 ModelM;
uniform float bulge;

out vec4 pos;
//out vec3 normal;
out vec2 uv0;

float PI = 3.14159265358979323846264;

void main( void )
{
    vec4 vertex = in_Position;
	//normal = NormalM * in_Normal;
    uv0 = in_UV0;
	
    float ty = (uv0.y * 1.25) - (0.25 / 2.0);
    ty = clamp(ty, 0.0, 1.0);    
    vertex.x *= 1.0 + (bulge * sin(ty * PI));
    vertex.z *= 1.0 + (bulge * sin(ty * PI));
	pos = vertex;
 	gl_Position = ProjM * ModelM * vertex;
}