#version 150 core

out vec4 fragColor;

uniform sampler2D image1;
uniform sampler2D image2;
uniform sampler2D image3;
uniform sampler2D image4;
uniform sampler2D image5;

uniform float fade;

in vec2 uv0;

vec4 blend(vec4 a, vec4 b)
{
	return max(a,b);
}

void main()
{
	vec4 p1 = texture(image1, uv0);
	vec4 p2 = texture(image2, uv0) * clamp(fade / 4.0, 0.0, 1.0);
	vec4 p3 = texture(image3, uv0) * clamp(fade / 6.0, 0.0, 1.0);
	vec4 p4 = texture(image4, uv0) * clamp(fade / 12.0, 0.0, 1.0);
	vec4 p5 = texture(image5, uv0) * clamp(fade / 16.0, 0.0, 1.0);

	vec4 c = p1;
	c = blend(c, p2);
	c = blend(c, p3);
	c = blend(c, p4);
	c = blend(c, p5);
	fragColor = c;
}